#include <windows.h>
#include <GL/glut.h>
#include <stdlib.h>
#include <stdio.h>
#include <iostream>
#include <math.h>
#include "structures.h"
#include "guepe_corps.h"
#include "guepe_corps_ailed1.h"
#include "guepe_corps_ailed2.h"
#include "guepe_corps_aileg1.h"
#include "guepe_corps_aileg2.h"
#include "guepe_corps_cul.h"
#include "guepe_corps_patted1.h"
#include "guepe_corps_patted2.h"
#include "guepe_corps_patted3.h"
#include "guepe_corps_patteg1.h"
#include "guepe_corps_patteg2.h"
#include "guepe_corps_patteg3.h"
#include "guepe_corps_tete.h"
#include "guepe_corps_tete_antenned.h"
#include "guepe_corps_tete_antenneg.h"
#include "arbre.h"
#include "sol.h"

float PI2 = 6.28318530718;
float PI = 3.14159265359;
float PIs2 = 3.14159265359 / 2;

Objet obj_Guepe = {{0., 0., 0.}, NULL, NULL, NULL, NULL, 0, 0, NULL, NULL, NULL, NULL};
float guepeEchelle = 1. / 600.;
bool guepeAttaque = false;

Objet* objets[17] = {    &obj_AileD1, &obj_AileD2,
                        &obj_AileG1, &obj_AileG2,
                        &obj_PatteD1, &obj_PatteD2, &obj_PatteD3,
                        &obj_PatteG1, &obj_PatteG2, &obj_PatteG3,
                        &obj_Tete, &obj_AntenneD, &obj_AntenneG,
                        &obj_Corps, &obj_Cul,

                        &obj_Arbre,
                        &obj_Sol

                        };
int nbObjets = 17;

int fenetre, vue1, vue2, vue3, vue4;

GLfloat matCoul[] = {1.0, 1.0, 1.0, 1.0};
GLfloat lumAmbiante[] = {.1, .17, .2, 1.};
GLfloat lumProj[] = {1., .90, .85, 1.2};
GLfloat lumProjPos[] = {-2., -10., 0.};

GLuint textureGuepe;
GLuint textureArbre;
GLuint textureRoute;
GLuint textureHerbe;

float camAngle = 0.0;
Vecteur cameraPos = {0.0, 0.0, 0.0};
float gravite = -0.01;
float friction = 0.95;
float frictionRot = 0.9;

int camerasHolo = 0;

char presse;
int anglex,angley,x,y,xold,yold;

/* Prototypes de fonctions */
void idle();
void affichage();
void affichageElements(int val);
void affichageTous();
void affichageVue1();
void affichageVue2();
void affichageVue3();
void affichageVue4();
void clavier(unsigned char touche,int x,int y);
void touches(int key, int x, int y);
void reshape(int x,int y);
void idle();
void mouse(int bouton,int etat,int x,int y);
void mousemotion(int x,int y);
void update(int val);

Vecteur vecteurPlus(Vecteur A, Vecteur B) {
    Vecteur retour;
    retour.x = A.x + B.x;
    retour.y = A.y + B.y;
    retour.z = A.z + B.z;
    return retour;
}
Vecteur vecteurMoins(Vecteur A, Vecteur B) {
    Vecteur retour;
    retour.x = A.x - B.x;
    retour.y = A.y - B.y;
    retour.z = A.z - B.z;
    return retour;
}
Vecteur vecteurProduit(Vecteur A, float B) {
    Vecteur retour;
    retour.x = A.x * B;
    retour.y = A.y * B;
    retour.z = A.z * B;
    return retour;
}

Vecteur produitVectoriel(Vecteur A, Vecteur B) {
    Vecteur retour;
    retour.x = A.y * B.z - A.z * B.y;
    retour.y = A.z * B.x - A.x * B.z;
    retour.z = A.x * B.y - A.y * B.x;
    return retour;
}

Vecteur vecteurNormaliser(Vecteur A) {
    Vecteur retour;
    float taille = sqrt(
                       pow(A.x, 2) + pow(A.y, 2) + pow(A.z, 2)
                       );
    retour.x = A.x / taille;
    retour.y = A.y / taille;
    retour.z = A.z / taille;
    return retour;
}

Vecteur calculeNormalePol(Vecteur A, Vecteur B, Vecteur C, Vecteur D) {
    Vecteur CA = vecteurMoins(A, C);
    Vecteur DB = vecteurMoins(B, D);
    return produitVectoriel(CA, DB);
}

float limite(float x, float a, float b) {
    if (x < a) return a;
    if (x > b) return b;
    return x;
}

void limCos(float* x) {
    if (*x > PI2) *x -= PI2;
}

GLuint LoadTexture(const char * filename, int width, int height) {
    GLuint texture;
    unsigned char * data;
    FILE* file;

    file = fopen(filename, "rb");

    if (file == NULL) return 0;

    data = (unsigned char *)malloc(width * height * 3);
    //int size = fseek(file,);
    fread(data, width * height * 3, 1, file);
    fclose(file);

    for (int i = 0; i < width * height ; ++i) {
        int index = i*3;
        unsigned char B,R;
        B = data[index];
        R = data[index+2];

        data[index] = R;
        data[index+2] = B;
    }


    glGenTextures( 1, &texture );
    glBindTexture( GL_TEXTURE_2D, texture );
    glTexEnvf( GL_TEXTURE_ENV, GL_TEXTURE_ENV_MODE,GL_MODULATE );
    glTexParameterf( GL_TEXTURE_2D, GL_TEXTURE_MIN_FILTER,GL_LINEAR_MIPMAP_NEAREST );


    glTexParameterf( GL_TEXTURE_2D, GL_TEXTURE_MAG_FILTER,GL_LINEAR );
    glTexParameterf( GL_TEXTURE_2D, GL_TEXTURE_WRAP_S,GL_REPEAT );
    glTexParameterf( GL_TEXTURE_2D, GL_TEXTURE_WRAP_T,GL_REPEAT );
    gluBuild2DMipmaps( GL_TEXTURE_2D, 3, width, height,GL_RGB, GL_UNSIGNED_BYTE, data );

    free( data );

    return texture;
}



void calculeNormaleObjet(Objet* _obj) {
    Vecteur (*_normales)[4] = _obj->normales;
    Vecteur *_p = _obj->points;
    int (*_f)[4] = _obj->polys;
    int nbPolys = _obj->nbpolys;
    int nbPts = _obj->nbpts;
    int i;
    Vecteur tabNorPts[nbPts];

    for (i = 0 ; i < nbPts ; i++) {
        tabNorPts[i] = {0.0, 0.0, 0.0};
    }

    for (i = 0 ; i < nbPolys ; i++) {
        Vecteur normalePoly = calculeNormalePol(_p[_f[i][0]], _p[_f[i][1]], _p[_f[i][2]], _p[_f[i][3]]);
        tabNorPts[_f[i][0]] = vecteurPlus(tabNorPts[_f[i][0]], normalePoly);
        tabNorPts[_f[i][1]] = vecteurPlus(tabNorPts[_f[i][1]], normalePoly);
        tabNorPts[_f[i][2]] = vecteurPlus(tabNorPts[_f[i][2]], normalePoly);
        tabNorPts[_f[i][3]] = vecteurPlus(tabNorPts[_f[i][3]], normalePoly);
    }

    for (i = 0 ; i < nbPts ; i++) {
        tabNorPts[i] = vecteurNormaliser(tabNorPts[i]);
    }

    for (i = 0 ; i < nbPolys ; i++) {
        _normales[i][0] = tabNorPts[_f[i][0]];
        _normales[i][1] = tabNorPts[_f[i][1]];
        _normales[i][2] = tabNorPts[_f[i][2]];
        _normales[i][3] = tabNorPts[_f[i][3]];
    }

    free(tabNorPts);
}

void physique(Objet* _obj) {
    if (!_obj) return;

    _obj->vit.y += gravite;
    _obj->vit.x *= friction;
    _obj->vit.z *= friction;
    _obj->posAbs = vecteurPlus(_obj->posAbs, _obj->vit);

    _obj->vitRotAngle *= frictionRot;
    _obj->angle3 += _obj->vitRotAngle;
    _obj->vitRot = vecteurProduit(_obj->vitRot, frictionRot);
    _obj->rotation3 = vecteurPlus(_obj->rotation3, _obj->vitRot);

    if (_obj->posAbs.y < 0.0) {
        _obj->vit.y = 0.0;
        _obj->posAbs.y = 0.000001;
    }

    {
        float _factSol = limite(_obj->posAbs.y, 0.0, 1.0);

        float _factAile = 30. * _factSol;
        float _factPatte = _obj->vit.y * 300 + _factSol * 40.;
        float _limPatteMin = limite(_obj->posAbs.y, 0.0, 1.0) * 60;
        float _factTete = 5. * _obj->vit.y;

        obj_AileD1.rotcos += 1.2 * _factAile;  limCos(&obj_AileD1.rotcos);
        obj_AileD1.angle = cos(obj_AileD1.rotcos) * 80. ;
        obj_AileD1.rotation = {.0, 1.0, .1};
        obj_AileD1.rotcos2 += 1.2 * _factAile; limCos(&obj_AileD1.rotcos2);
        obj_AileD1.angle2 = cos(obj_AileD1.rotcos2) * 85. + 20. ;
        obj_AileD1.rotation2 = {.0, .0, 1.0};

        obj_AileD2.rotcos += 1.2 * _factAile;  limCos(&obj_AileD2.rotcos);
        obj_AileD2.angle = cos(obj_AileD2.rotcos) * 50.;
        obj_AileD2.rotation = {.0, 1.0, .0};
        obj_AileD2.rotcos2 += 1.2 * _factAile; limCos(&obj_AileD2.rotcos2);
        obj_AileD2.angle2 = cos(obj_AileD2.rotcos2) * 55. + 20. ;
        obj_AileD2.rotation2 = {.0, .0, 1.0};

        obj_AileG1.rotcos += 1.2 * _factAile;  limCos(&obj_AileG1.rotcos);
        obj_AileG1.angle = cos(obj_AileG1.rotcos) * -80.;
        obj_AileG1.rotation = {.0, 1.0, -.1};
        obj_AileG1.rotcos2 += 1.2 * _factAile; limCos(&obj_AileG1.rotcos2);
        obj_AileG1.angle2 = cos(obj_AileG1.rotcos2) * -85. - 20. ;
        obj_AileG1.rotation2 = {.0, .0, -1.0};

        obj_AileG2.rotcos += 1.2 * _factAile;  limCos(&obj_AileG2.rotcos);
        obj_AileG2.angle = cos(obj_AileG2.rotcos) * -50.;
        obj_AileG2.rotation = {.0, 1.0, .0};
        obj_AileG2.rotcos2 += 1.2 * _factAile; limCos(&obj_AileG2.rotcos2);
        obj_AileG2.angle2 = cos(obj_AileG2.rotcos2) * -55. - 20. ;
        obj_AileG2.rotation2 = {.0, .0, -1.0};


        obj_PatteD1.angle = limite(_factPatte, _limPatteMin, 80.);
        obj_PatteD1.rotation = {1.2, 1.2, 0.0};
        obj_PatteD2.angle = limite(_factPatte, _limPatteMin, 80.);
        obj_PatteD2.rotation = {1.0, .8, 0.0};
        obj_PatteD3.angle = limite(_factPatte, _limPatteMin, 80.);
        obj_PatteD3.rotation = {1.0, .2, 0.0};

        obj_PatteG1.angle = limite(_factPatte, _limPatteMin, 80.);
        obj_PatteG1.rotation = {-1.2, -1.2, 0.0};
        obj_PatteG2.angle = limite(_factPatte, _limPatteMin, 80.);
        obj_PatteG2.rotation = {-1.0, -.8, 0.0};
        obj_PatteG3.angle = limite(_factPatte, _limPatteMin, 80.);
        obj_PatteG3.rotation = {-1.0, -.2, 0.0};

        obj_Tete.angle = limite(20. * _factTete, 0.0, 20.);
        obj_Tete.rotation = {0., 0., 1};


        obj_AntenneD.rotcos += 0.015;
        limCos(&obj_AntenneD.rotcos);
        obj_AntenneD.angle = cos(obj_AntenneD.rotcos) * 20;
        obj_AntenneD.rotation = {1., 0., 0};

        obj_AntenneG.rotcos += 0.016;
        limCos(&obj_AntenneG.rotcos);
        obj_AntenneG.angle = cos(obj_AntenneG.rotcos) * 20;
        obj_AntenneG.rotation = {1., 0., 0};


        // Attaque
        if (guepeAttaque) {
            obj_Cul.angle += 10.;
            obj_Cul.rotation = {0., 0., -1};
            if (obj_Cul.angle > 90) guepeAttaque = false;
        }
        else {
            obj_Cul.angle = limite(20. * _factTete, 0.0, 20.);
            obj_Cul.rotation = {0., 0., -1};
        }

        // Pose au sol
        if (_obj->posAbs.y <= 0.000001) {
            obj_AileD1.angle = 0.0;
            obj_AileD1.angle2 = 0.0;
            obj_AileD2.angle = 0.0;
            obj_AileD2.angle2 = 0.0;
            obj_AileG1.angle = 0.0;
            obj_AileG2.angle = 0.0;
            obj_AileG1.angle2 = 0.0;
            obj_AileG2.angle2 = 0.0;
        }

        // Animation pattes
        {
            float vitesse = sqrt(_obj->vit.x * _obj->vit.x + _obj->vit.z * _obj->vit.z);
            vitesse *= 50;

            vitesse *= 1. - limite(_obj->posAbs.y, 0.0, 1.0);;

            if (_obj->posAbs.y < 0.1) {

                // Patte avant gauche

                obj_PatteD1.rotcos += 0.1 * vitesse;
                limCos(&obj_PatteD1.rotcos);
                obj_PatteD1.angle = cos(obj_PatteD1.rotcos) * 20;
                obj_PatteD1.rotation = {0., 1., 0.};

                obj_PatteD1.rotcos2 += 0.1 * vitesse;
                limCos(&obj_PatteD1.rotcos2);
                obj_PatteD1.angle2 = cos(obj_PatteD1.rotcos2 + PIs2) * 20;
                obj_PatteD1.rotation2 = {0., 0., 1.};

                // Patte avant droite

                obj_PatteG1.rotcos += -0.1 * vitesse;
                limCos(&obj_PatteG1.rotcos);
                obj_PatteG1.angle = cos(obj_PatteG1.rotcos) * 20;
                obj_PatteG1.rotation = {0., 1., 0.};

                obj_PatteG1.rotcos2 += -0.1 * vitesse;
                limCos(&obj_PatteG1.rotcos2);
                obj_PatteG1.angle2 = cos(obj_PatteG1.rotcos2 + PIs2) * 20;
                obj_PatteG1.rotation2 = {0., 0., 1.};

                // Patte milieu gauche

                obj_PatteD2.rotcos += 0.1 * vitesse;
                limCos(&obj_PatteD2.rotcos);
                obj_PatteD2.angle = cos(obj_PatteD2.rotcos + PIs2) * 20;
                obj_PatteD2.rotation = {0., 1., 0.};

                obj_PatteD2.rotcos2 += 0.1 * vitesse;
                limCos(&obj_PatteD2.rotcos2);
                obj_PatteD2.angle2 = cos(obj_PatteD2.rotcos2) * 20;
                obj_PatteD2.rotation2 = {0., 0.5, 1.};

                // Patte milieu droite

                obj_PatteG2.rotcos += -0.1 * vitesse;
                limCos(&obj_PatteG2.rotcos);
                obj_PatteG2.angle = cos(obj_PatteG2.rotcos + 1.7) * 20;
                obj_PatteG2.rotation = {0., 1., 0.};

                obj_PatteG2.rotcos2 += 0.1 * vitesse;
                limCos(&obj_PatteG2.rotcos2);
                obj_PatteG2.angle2 = cos(obj_PatteG2.rotcos2 + PIs2) * 20;
                obj_PatteG2.rotation2 = {0., 0., 1.};

                // Patte arrre gauche

                obj_PatteD3.rotcos += 0.1 * vitesse;
                limCos(&obj_PatteD3.rotcos);
                obj_PatteD3.angle = cos(obj_PatteD3.rotcos) * 20;
                obj_PatteD3.rotation = {0., 1., 0.};

                obj_PatteD3.rotcos2 += 0.1 * vitesse;
                limCos(&obj_PatteD3.rotcos2);
                obj_PatteD3.angle2 = cos(obj_PatteD3.rotcos2 + PIs2) * 20;
                obj_PatteD3.rotation2 = {1., 0., 0.};

                // Patte arrre droite

                obj_PatteG3.rotcos += -0.1 * vitesse;
                limCos(&obj_PatteG3.rotcos);
                obj_PatteG3.angle = cos(obj_PatteG3.rotcos) * 20;
                obj_PatteG3.rotation = {0., 1., 0.};

                obj_PatteG3.rotcos2 += 0.1 * vitesse;
                limCos(&obj_PatteG3.rotcos2);
                obj_PatteG3.angle2 = cos(obj_PatteG3.rotcos2 + PIs2) * 20;
                obj_PatteG3.rotation2 = {1., 0., 0.};
            }
        }
    }


}

void initialiseObjets() {

    for (int i = 0 ; i < nbObjets ; i++) {
        calculeNormaleObjet(*(objets + i));
        objets[i]->enfant = NULL;
        objets[i]->parent = NULL;
        objets[i]->suivant = NULL;
        objets[i]->precedent = NULL;
        objets[i]->rotation = {0.0, 0.0, 0.0};
        objets[i]->angle = 0.0;
        objets[i]->rotcos = 0.0;
        objets[i]->rotation2 = {0.0, 0.0, 0.0};
        objets[i]->angle2 = 0.0;
        objets[i]->rotcos2 = 0.0;
        objets[i]->vit = {0.0, 0.0, 0.0};
        objets[i]->ech = {1.0, 1.0, 1.0};
        objets[i]->posAbs = {0.0, 0.0, 0.0};
        objets[i]->angle3 = 0.0;
        objets[i]->rotation3 = {0.0, 0.0, 0.0};
        objets[i]->vitRot = {0.0, 0.0, 0.0};
        objets[i]->vitRotAngle = 0;
    }
    obj_Guepe.ech = {1. / 600., 1. / 600., 1. / 600.};
    obj_Arbre.ech = {.02, .02, .02};
    obj_Arbre.ech = {.1, .1, .1};
    obj_Arbre.posAbs = {0, 0, -8};
    obj_Sol.ech = {.1, .1, .1};

/*
    obj_Guepe.enfant = &obj_Corps;

    obj_Corps.parent = &obj_Guepe;
    obj_Corps.enfant = &obj_Tete;

    obj_Tete.parent = &obj_Corps;
    obj_Tete.suivant = &obj_PatteD1;

    obj_PatteD1.parent = &obj_Corps;
    obj_PatteD1.precedent = &obj_Tete;
    obj_PatteD1.suivant = &obj_PatteD2;

    obj_PatteD2.parent = &obj_Corps;
    obj_PatteD2.precedent = &obj_PatteD1;
    obj_PatteD2.suivant = &obj_PatteD3;

    obj_PatteD3.parent = &obj_Corps;
    obj_PatteD3.precedent = &obj_PatteD2;
    obj_PatteD3.suivant = &obj_Cul;

    obj_Cul.parent = &obj_Corps;
    obj_Cul.precedent = &obj_PatteD3;
*/


    obj_Guepe.enfant = &obj_Corps;

    obj_Corps.parent = &obj_Guepe;
    obj_Corps.enfant = &obj_Tete;

    obj_Tete.parent = &obj_Corps;
    obj_Tete.enfant = &obj_AntenneG;
    obj_Tete.suivant = &obj_PatteD1;

    obj_AntenneG.parent = &obj_Tete;
    obj_AntenneG.suivant = &obj_AntenneD;

    obj_AntenneD.parent = &obj_Tete;
    obj_AntenneD.precedent = &obj_AntenneG;

    obj_PatteD1.parent = &obj_Corps;
    obj_PatteD1.precedent = &obj_Tete;
    obj_PatteD1.suivant = &obj_PatteD2;

    obj_PatteD2.parent = &obj_Corps;
    obj_PatteD2.precedent = &obj_PatteD1;
    obj_PatteD2.suivant = &obj_PatteD3;

    obj_PatteD3.parent = &obj_Corps;
    obj_PatteD3.precedent = &obj_PatteD2;
    obj_PatteD3.suivant = &obj_Cul;

    obj_Cul.parent = &obj_Corps;
    obj_Cul.precedent = &obj_PatteD3;


    calculeNormaleObjet(&obj_Guepe);


}

void initVue() {

	/* Initialisation d'OpenGL */
	GLfloat r = .0;
	GLfloat v = .0;
	GLfloat b = .0;
	GLfloat a = 1.0;
	glClearColor(r, v, b, a);

	glColor3f(1.0, 1.0, 1.0);
	glPointSize(2.0);

	glEnable(GL_DEPTH_TEST);


    glEnable(GL_LIGHTING);
    glEnable(GL_LIGHT0);
    glEnable(GL_TEXTURE_2D);
   /* glEnable(GL_NORMALIZE);
    glShadeModel(GL_SMOOTH);
    glDisable(GL_COLOR_MATERIAL);*/

	glutKeyboardFunc(clavier);
	glutSpecialFunc(touches);
	glutMouseFunc(mouse);
	glutMotionFunc(mousemotion);

}

int main(int argc, char **argv){

    initialiseObjets();

    glutInit(&argc, argv);
    glutInitDisplayMode(GLUT_DEPTH | GLUT_RGB);
    glutInitWindowSize(1400, 900);
	glutInitWindowPosition (100, 100);

    int fenetre = glutCreateWindow("Gupe");
    glutFullScreen();
    glutDisplayFunc(affichage);
	glutReshapeFunc(reshape);
    glutIdleFunc(idle);


    vue4 = glutCreateSubWindow(fenetre, 0, 0, 1920, 1080);
    glutDisplayFunc(affichageVue4);

    initVue();

    textureGuepe = LoadTexture("guepe.bmp", 4096, 4096);
    textureArbre = LoadTexture("arbre.bmp", 1024, 512);
    textureRoute = LoadTexture("sol.bmp", 2048, 2048);

    //

    vue1 = glutCreateSubWindow(fenetre, 0, 440, 700, 700);
    glutDisplayFunc(affichageVue1);

    initVue();

    textureGuepe = LoadTexture("guepe.bmp", 4096, 4096);
    textureArbre = LoadTexture("arbre.bmp", 1024, 512);
    textureRoute = LoadTexture("sol.bmp", 2048, 2048);

    //

    vue2 = glutCreateSubWindow(fenetre, 640-80, 0, 800, 600);
    glutDisplayFunc(affichageVue2);

    initVue();

    textureGuepe = LoadTexture("guepe.bmp", 4096, 4096);
    textureArbre = LoadTexture("arbre.bmp", 1024, 512);
    textureRoute = LoadTexture("sol.bmp", 2048, 2048);

    //

    vue3 = glutCreateSubWindow(fenetre, 640*2-80, 440, 700, 700);
    glutDisplayFunc(affichageVue3);

    initVue();

    textureGuepe = LoadTexture("guepe.bmp", 4096, 4096);
    textureArbre = LoadTexture("arbre.bmp", 1024, 512);
    textureRoute = LoadTexture("sol.bmp", 2048, 2048);

    //

	glutTimerFunc(20, update, 0);

	/* Entre dans la boucle principale de glut */
    glutMainLoop();

    return 0;
}


void affichageLumiere() {

    glLightfv(GL_LIGHT0, GL_AMBIENT , lumAmbiante);

    glLightfv(GL_LIGHT0, GL_DIFFUSE , lumProj);
    glLightfv(GL_LIGHT0, GL_POSITION, lumProjPos);

}

void dessineObjet(Objet* _obj) {
    int i, imax = _obj->nbpolys, j;

    glTranslatef(_obj->posAbs.x, _obj->posAbs.y, _obj->posAbs.z); // Translation absolue
    glScalef(_obj->ech.x, _obj->ech.y, _obj->ech.z); // chelle

    glRotatef(_obj->angle3, _obj->rotation3.x, _obj->rotation3.y, _obj->rotation3.z); // Rotation avant la translation

    glTranslatef(_obj->pos.x, _obj->pos.y, _obj->pos.z);
    glRotatef(_obj->angle, _obj->rotation.x, _obj->rotation.y, _obj->rotation.z);
    glRotatef(_obj->angle2, _obj->rotation2.x, _obj->rotation2.y, _obj->rotation2.z);

	// Pour chaque polygone
	for (i = 0 ; i < imax ; i++)
	{
		glBegin(GL_POLYGON);

		for (j = 0 ; j < 4 ; j++)
		{
            Vecteur normalePol  = _obj->normales[i][j];
            glNormal3f(normalePol.x, normalePol.y, normalePol.z);

            glTexCoord2f(_obj->uvs[i][j].u + .005, 1.0 - _obj->uvs[i][j].v);

			glVertex3f(_obj->points[_obj->polys[i][j]].x,
                       _obj->points[_obj->polys[i][j]].y,
                       _obj->points[_obj->polys[i][j]].z);
		}
		glEnd();
	}

}

void idle() {

}

void affichage() {
	/*glutSetWindow(fenetre);
	glClear(GL_COLOR_BUFFER_BIT);
	glutSwapBuffers();*/
	glClear(GL_COLOR_BUFFER_BIT);
}

void affichageTous() {
    if (camerasHolo) {
        affichageVue1();
        affichageVue2();
        affichageVue3();
    }
    else {
        affichageVue4();
    }
}

void affichageVue1() {
    if (!camerasHolo) return;
    glutSetWindow(vue1);
    affichageElements(1);
}

void affichageVue2() {
    if (!camerasHolo) return;
    glutSetWindow(vue2);
    affichageElements(2);
}

void affichageVue3() {
    if (!camerasHolo) return;
    glutSetWindow(vue3);
    affichageElements(3);
}

void affichageVue4() {

    glutSetWindow(vue4);
    glClear(GL_COLOR_BUFFER_BIT);

    if (!camerasHolo) affichageElements(4);
}

Vecteur calculeCam(int ax, int ay) {
    Vecteur _c = {1,1,1};
    _c.x = 2 * sin(ax * 3.14 / 180.) * cos(ay * 3.14 / 180.) + cameraPos.x;
    _c.y = 2 * sin(ay * 3.14 / 180.) + cameraPos.y;
    _c.z = 2 * cos(ax * 3.14 / 180.) * cos(ay * 3.14 / 180.) + cameraPos.z;
    return _c;
}

Vecteur calculeU(Vecteur camPos, Vecteur ciblePos, int idCam) {

    Vecteur _v1 = vecteurMoins(camPos, ciblePos);
    Vecteur _v2 = vecteurMoins(camPos, ciblePos); _v2.y = 0;
    Vecteur _u;

    if (idCam == 2) { // Milieu
        Vecteur _w = produitVectoriel(_v1, _v2);
        _u = produitVectoriel(_v1, _w);
        _u = vecteurProduit(_u, -1);

        if (camPos.y - ciblePos.y < 0) _u = vecteurProduit(_u, -1);
    }

    else if (idCam == 1) { // Gauche
        _u = produitVectoriel(_v1, _v2);
        _u = vecteurProduit(_u, -1);

        if (camPos.y - ciblePos.y < 0) _u = vecteurProduit(_u, -1);
    }

    else if (idCam == 3) { // Droite
        _u = produitVectoriel(_v1, _v2);

        if (camPos.y - ciblePos.y < 0) _u = vecteurProduit(_u, -1);
    }

    else if (idCam == 4) { // Gauche
        Vecteur _w = produitVectoriel(_v1, _v2);
        _u = produitVectoriel(_v1, _w);

        if (camPos.y - ciblePos.y < 0) _u = vecteurProduit(_u, -1);
    }

    return _u;
}

void affichageElements(int val) {

	// Effacement de l'image avec la couleur de fond
	glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);

    glMatrixMode(GL_PROJECTION);
	glLoadIdentity();

    // Lumire
    affichageLumiere();

    // Camra
    float facteurRetard = 0.1;
    if (val == 4) // Vue seule
        facteurRetard = 0.05; // Camra trs souple en mode plein cran

    Vecteur _cameraPosRetard = vecteurMoins(obj_Guepe.posAbs, cameraPos);
    cameraPos = vecteurPlus(cameraPos, vecteurProduit(_cameraPosRetard, facteurRetard));


    switch(val) {
        case 1 : // Gauche
            {
                gluPerspective(60., 1., 0.01, 40.);
                Vecteur camPos = calculeCam(anglex + 90, angley);
                Vecteur _u = calculeU(camPos, obj_Guepe.posAbs, 1);

                gluLookAt(camPos.x, camPos.y, camPos.z, // Position de la camra
                        obj_Guepe.posAbs.x, obj_Guepe.posAbs.y, obj_Guepe.posAbs.z, // Position o la cam regarde
                        _u.x, _u.y, _u.z); // Vecteur haut
            }
            break;

        case 2 : // Centre
            {
                gluPerspective(50., 800/600., 0.01, 40.);
                glTranslatef(0, .25, 0);

                Vecteur camPos = calculeCam(anglex, angley);
                Vecteur _u = calculeU(camPos, obj_Guepe.posAbs, 2);

                gluLookAt(camPos.x, camPos.y, camPos.z, // Position de la camra
                        obj_Guepe.posAbs.x, obj_Guepe.posAbs.y, obj_Guepe.posAbs.z, // Position o la cam regarde
                        _u.x, _u.y, _u.z); // Vecteur haut
            }
            break;

        case 3 : // Droite
            {
                gluPerspective(60., 1., 0.01, 40.);
                Vecteur camPos = calculeCam(anglex - 90, angley);
                Vecteur _u = calculeU(camPos, obj_Guepe.posAbs, 3);

                gluLookAt(camPos.x, camPos.y, camPos.z, // Position de la camra
                        obj_Guepe.posAbs.x, obj_Guepe.posAbs.y, obj_Guepe.posAbs.z, // Position o la cam regarde
                        _u.x, _u.y, _u.z); // Vecteur haut
            }
            break;

        case 4 : // Vue seule
            {
                gluPerspective(60., 1920. / 1080. , 0.01, 40.);
                Vecteur camPos = calculeCam(anglex, angley);
                Vecteur _u = calculeU(camPos, obj_Guepe.posAbs, 4);

                gluLookAt(camPos.x, camPos.y, camPos.z, // Position de la camra
                        obj_Guepe.posAbs.x, obj_Guepe.posAbs.y, obj_Guepe.posAbs.z, // Position o la cam regarde
                        _u.x, _u.y, _u.z); // Vecteur haut
            }
            break;

        default : break;
    }

    // Gupe

    glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, matCoul);
    glBindTexture(GL_TEXTURE_2D, textureGuepe);

    glPushMatrix();
    dessineObjet(&obj_Guepe);



    dessineObjet(&obj_Corps); // A un enfant

    glPushMatrix();

    dessineObjet(&obj_Tete); // A un enfant

    glPushMatrix();
    dessineObjet(&obj_AntenneG); // A un suivant
    glPopMatrix();

    glPushMatrix();
    dessineObjet(&obj_AntenneD); // Suivant
    glPopMatrix();

    glPopMatrix();

    glPushMatrix();
    dessineObjet(&obj_Cul); // Parent, Suivant
    glPopMatrix();

    glPushMatrix();
    dessineObjet(&obj_PatteD1); // Suivant
    glPopMatrix();

    glPushMatrix();
    dessineObjet(&obj_PatteD2); // Suivant
    glPopMatrix();

    glPushMatrix();
    dessineObjet(&obj_PatteD3); // Suivant
    glPopMatrix();

    glPushMatrix();
    dessineObjet(&obj_PatteG1); // Suivant
    glPopMatrix();

    glPushMatrix();
    dessineObjet(&obj_PatteG2); // Suivant
    glPopMatrix();

    glPushMatrix();
    dessineObjet(&obj_PatteG3); // Suivant
    glPopMatrix();

    glPushMatrix();
    dessineObjet(&obj_AileD1); // Suivant
    glPopMatrix();

    glPushMatrix();
    dessineObjet(&obj_AileD2); // Suivant
    glPopMatrix();

    glPushMatrix();
    dessineObjet(&obj_AileG1); // Suivant
    glPopMatrix();

    glPushMatrix();
    dessineObjet(&obj_AileG2); // Suivant
    glPopMatrix();


    glPopMatrix();


    if (val == 4) { // Si vue seule, afficher le sol et l'arbre

        // Ciel
        glClearColor(25/255., 77/255., 116/255., 1.);

        // Arbre

        glBindTexture(GL_TEXTURE_2D, textureArbre);

        glPushMatrix();
        dessineObjet(&obj_Arbre);
        glPopMatrix();

        glPushMatrix();
        glTranslatef(10, 0, 10);
        dessineObjet(&obj_Arbre);
        glPopMatrix();

        glPushMatrix();
        glTranslatef(20, 0, -10);
        dessineObjet(&obj_Arbre);
        glPopMatrix();

        glPushMatrix();
        glTranslatef(30, 0, 20);
        dessineObjet(&obj_Arbre);
        glPopMatrix();

        // Sol

        glBindTexture(GL_TEXTURE_2D, textureRoute);

        glPushMatrix();
        dessineObjet(&obj_Sol);
        glPopMatrix();

    }

	glFlush();
	// On change les buffers
	glutSwapBuffers();
}

void update(int val) {

    physique(&obj_Guepe);

    //
    affichageTous();
    //glutPostRedisplay();

    glutTimerFunc(15, update, 0);
}

/* Evenement du clavier */
void touches(int key, int x, int y) {
    switch(key) {
        case GLUT_KEY_UP:
            obj_Guepe.vit.x -= cos(-obj_Guepe.angle3 * 0.017) * 0.1;
            obj_Guepe.vit.z -= sin(-obj_Guepe.angle3 * 0.017) * 0.1;
        break;
        case GLUT_KEY_DOWN:
            obj_Guepe.vit.x += cos(-obj_Guepe.angle3 * 0.017) * 0.1;
            obj_Guepe.vit.z += sin(-obj_Guepe.angle3 * 0.017) * 0.1;
        break;
        case GLUT_KEY_LEFT:
            obj_Guepe.vitRot.y = 1;
            obj_Guepe.vitRotAngle += 5;
        break;
        case GLUT_KEY_RIGHT:
            obj_Guepe.vitRot.y = 1;
            obj_Guepe.vitRotAngle -= 5;
        break;
    }
}
void clavier(unsigned char touche,int x,int y){
    printf("%c", touche);
	switch (touche){

        case '/':
            guepeAttaque = true;
            //break;

        // Petit saut
        case 'c':
            obj_Guepe.vit.y = 0.09;
            obj_Guepe.posAbs.y += 0.001;
            break;

        // Mode vue seule / Hologramme
        case '*':
        case 'h':
            camerasHolo = !camerasHolo;
            if (camerasHolo) {
                glutSetWindow(vue4);
                glutReshapeWindow(0,0);
            }
            else {
                glutSetWindow(vue4);
                glutReshapeWindow(1920, 1080);
            }
            break;

        // Saute
        case '+':
        case '5':
        case ' ':
            obj_Guepe.vit.y = 0.2;
            obj_Guepe.posAbs.y += 0.001;
            break;

		case 'p':/*affichage du carr plein*/
			glPolygonMode(GL_FRONT_AND_BACK,GL_FILL);
			glutPostRedisplay();
			break;

		case 'f':/*affichage en mode fil de fer*/
			glPolygonMode(GL_FRONT_AND_BACK,GL_LINE);
			glutPostRedisplay();
			break;

		case 's':/*affichage en mode sommets seuls*/
			glPolygonMode(GL_FRONT_AND_BACK,GL_POINT);
			glutPostRedisplay();
			break;
		case 'd':
			glEnable(GL_DEPTH_TEST);
			glutPostRedisplay();
			break;
		case 'D':
			glDisable(GL_DEPTH_TEST);
			glutPostRedisplay();
			break;
		case 'q':/* Quitter le programme */
			exit(0);
	}
}


void reshape(int x,int y)
{
	if (x < y)
		//glViewport(0,(y-x)/2,x,x);
		glViewport(0,50,54,x);
	else
		glViewport((x-y)/2,0,y,y);
}


void mouse(int button,int state,int x,int y)
{
	// Si on appuie sur le bouton de gauche
	if (button == GLUT_LEFT_BUTTON && state == GLUT_DOWN)
	{
		presse = 1; //le booleen presse passe  1 (vrai)
		xold = x; //on sauvegardela position de la souris
		yold = y;
	}

	// Si on relache le bouton gauche
	if (button == GLUT_LEFT_BUTTON && state == GLUT_UP)
		presse = 0; //le booleen presse passe  0 (faux)
}


void mousemotion(int x,int y)
{
	if (presse) // si le bouton de gauche est press
	{
		/* On modifie les angles de rotation de l'objet en fonction de la
		position actuelle de la souris et de la dernire position suvegarde*/
		anglex = anglex + (x - xold);
		angley = angley + (y - yold);
		glutPostRedisplay(); // Rafraichissement de l'affichage
	}
	xold = x; //sauvegarde des valeurs courantes de la position de la souris
	yold = y;
}
